import { closeIcon } from '@genesislcap/foundation-ui';
import { html, repeat } from '@microsoft/fast-element';
const getSystemHealthAlertsServiceMessageTemplate = (prefix, item, state) => html `
  <${prefix}-snackbar
    identifier=${item.tag}
    class="service-status-message service-status-message-${state}"
    auto-close="${(x, c) => c.parent.autoClose}"
    close-timeout="${(x, c) => c.parent.closeTimeout}"
    @autoDismiss=${(x, c) => c.parent.closeMessageHandler(c.event)}
  >
    <p class="content" slot="content">
      <span class="content-element content-service-name">${(ignore, c) => c.parent.getTextHelper('title', state, item)}</span>
      <span class="content-element content-text">
        ${(ignore, c) => c.parent.getTextHelper('message', state, item)}
      </span>
      <span class="content-element content-buttons">
        <${prefix}-button class="link" @click=${() => confirm('Reload the page?') && location.reload()}>
          Reload
        </${prefix}-button>
      </span>
    </p>
    ${state === 'restored'
    ? html `<section class="action" slot="action">
          <${prefix}-button class="button-close" @click=${(x, c) => c.parent.emitCloseMessage(c.event.target, item.tag)}>
            ${closeIcon('start', 'var(--close-icon-fill)')}
          </${prefix}-button>
        </section>`
    : ''}
  </${prefix}-snackbar>
`;
/**
 * @public
 */
export const getPrefixedSystemHealthAlertsService = (designSystemPrefix, templates = {
    restored: (prefix, item) => getSystemHealthAlertsServiceMessageTemplate(prefix, item, 'restored'),
    failed: (prefix, item) => getSystemHealthAlertsServiceMessageTemplate(prefix, item, 'failed'),
}) => html `
  <div class="services-status" data-test-id="services-status">
    <slot>
      ${repeat((x) => x.displayMessages, html `
          ${(item) => item.isConnected
    ? templates.restored(designSystemPrefix, item)
    : templates.failed(designSystemPrefix, item)}
        `)}
    </slot>
  </div>
`;
